<?php

/**
 * Custom blocks
 *
 * @package CustomBlocks
 * @version 2.5
 * @author davidhs
 * @copyright 2013-2018 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License https://creativecommons.org/licenses/by/3.0/
 */

// Template for admin area settings (edit).
function template_cb_settings_edit()
{
	global $txt, $scripturl, $context, $settings;

	echo '
	<form action="', $scripturl, '?action=featuresettings;sa=cbedit;pos=', $context['pos'], ';id=', $context['id'], $context['params_url'], ';sesc=', $context['session_id'], '" method="post" accept-charset="', $context['character_set'], '">
		<table width="80%" border="0" cellspacing="0" cellpadding="0" class="tborder" align="center">
			<tr><td>
				<table border="0" cellspacing="0" cellpadding="4" width="100%">
					<tr class="titlebg">
						<td colspan="3">', $context['settings_title'], '</td>
					</tr>';

	if (!empty($context['id']))
	{
		echo '
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="pos_new">', $txt['cb_position'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<select name="pos_new" id="pos_new">';

		foreach ($context['params']['pos_array'] as $pos_type)
		{
			echo '
								<option value="" disabled="disabled">-----------------------------</option>
								<option value="" disabled="disabled">', $pos_type['name'], '</option>
								<option value="" disabled="disabled">-----------------------------</option>';
			foreach ($pos_type['pos_array'] as $k => $v)
				echo '
								<option value="', $k, '"', $context['pos'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';
		}

		echo '
							</select>
						</td>
					</tr>';
	}

	echo '
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="description">', $txt['cb_description'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<textarea name="description" id="description" rows="2" cols="30">', $context['params']['description'], '</textarea>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="cb_frame">', $txt['cb_frame'], '</label><br />
							<span class="smalltext">', $txt['cb_frame_desc'], '</span>
						</td>
						<td class="windowbg2" width="50%">
							<textarea name="frame" id="cb_frame" rows="4" cols="30" style="min-width: 90%;">', $context['params']['frame'], '</textarea>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="type">', $txt['cb_type'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<select name="type" id="type">';

	foreach ($context['params']['type_array'] as $k => $v)
		echo '
								<option value="', $k, '"', $context['params']['type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
							</select>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=cb_content" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" border="0" align="top" /></a></td>
						<td valign="top">
							<label for="content">', $txt['cb_content'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<textarea name="content" id="content" rows="4" cols="30" style="min-width: 90%;">', $context['params']['content'], '</textarea>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="order">', $txt['cb_order'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<input type="text" name="order" id="order" value="', $context['params']['order'], '" size="5" />
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							', $txt['cb_permissions'], '<br />
							<span class="smalltext">', $txt['cb_permissions_desc'], '</span>
						</td>
						<td class="windowbg2" width="50%">
							<table>
								<tr>
									<td>&nbsp;</td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
									<td align="center">', $txt_pa, '</td>';
	echo '
								</tr>';
	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
								<tr>
									<td align="left">', $txt_pu, '</td>';
		foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		{
			$perm = $pu . ':' . $pa;
			$perm_id = $pu . '_' . $pa;
			echo '
									<td align="center"><input type="checkbox" name="permissions[]" id="permissions_' . $perm_id . '" value="' . $perm . '"' . (in_array($perm, $context['params']['permissions']) ? ' checked="checked"' : '') . ' class="check" />', '</td>';
		}
		echo '
								</tr>';
	}
	echo '
								<tr>
									<td align="left"><i>', $txt[737], '</i></td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
									<td align="center"><input type="checkbox" name="check_all_permissions_', $pa, '" id="check_all_permissions_', $pa, '" value="" class="check" /></td>';
	echo '
								</tr>
							</table>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="active">', $txt['cb_active'], '</label><br />
							<span class="smalltext">', $txt['cb_active_desc'], '</span>
						</td>
						<td class="windowbg2" width="50%">
							<input type="checkbox" name="active" id="active" value="1"', $context['params']['active'] ? ' checked="checked"' : '', ' class="check" />
						</td>
					</tr>
					<tr>
						<td class="windowbg2" colspan="3" align="center" valign="middle"><input type="submit" name="save" value="', $txt[10], '" accesskey="s" /></td>
					</tr>
				</table>
			</td></tr>
		</table>
	</form>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[';

	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
	{
		echo '

		document.getElementById("check_all_permissions_', $pa, '").onclick = function (event)
		{';
		foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
		{
			$perm_id = $pu . '_' . $pa;
			echo '
			if (document.getElementById("permissions_', $perm_id, '"))
				document.getElementById("permissions_', $perm_id, '").checked = this.checked;';
		}
		echo '
		}';
	}

	echo '
	// ]]></script>';
}

// Template for admin area settings (show).
function template_cb_settings_show()
{
	global $txt, $scripturl, $context, $settings;

	$pos_array = cbGetPositions();

	echo '
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="tborder" align="center">
		<tr><td>
			<table border="0" cellspacing="0" cellpadding="4" width="100%">
				<tr class="titlebg">
					<td valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=cb" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" border="0" align="top" /></a></td>
					<td>', $context['settings_title'], '</td>
				</tr>
			</table>
			<table cellpadding="0" cellspacing="0" border="0" style="margin-left: 10px;">
				<tr>
					<td class="maintab_first">&nbsp;</td>';

	foreach ($pos_array as $pos_type => $v)
	{
		$link = '<a href="' . $scripturl . '?action=featuresettings;sa=cb;pos_type=' . $pos_type . '">' . $txt['cb_position_type_' . $pos_type] . '</a>';
		if ($pos_type == $context['pos_type'])
		{
			echo '
					<td class="maintab_active_first">&nbsp;</td>
					<td class="maintab_active_back">', $link, '</td>
					<td class="maintab_active_last">&nbsp;</td>';
		}
		else
			echo '
					<td class="maintab_back">', $link, '</td>';
	}

	echo '
					<td class="maintab_last">&nbsp;</td>
				</tr>
			</table>';

	foreach ($pos_array[$context['pos_type']] as $pos => $v)
	{
		echo '
			<br />';
		template_cb_show_list('cb_settings_show_' . $pos);
	}

	echo '
		</td></tr>
	</table>';
}

?>